/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: getCharArrayOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the getCharArrayOperationDispatcher. It contains of all the generic methods
    for getCharArrayOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef getCharArrayOperationDispatcher_HXX
#define getCharArrayOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class getCharArrayOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::getCharArrayOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        getCharArrayOperationDispatcher();
        virtual ~getCharArrayOperationDispatcher();
        static OperationDispatcher *constructor();

        void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

        void getCharArrayPreConditions( const Teamcenter::BusinessObject* obj, std::vector<char>& charValues, std::vector<int>& isNullValues ) const;
        void getCharArrayPreActions( const Teamcenter::BusinessObject* obj, std::vector<char>& charValues, std::vector<int>& isNullValues ) const;
        void getCharArrayBaseAction( const Teamcenter::BusinessObject* obj, std::vector<char>& charValues, std::vector<int>& isNullValues ) const;
        void getCharArrayPostActions( const Teamcenter::BusinessObject* obj, std::vector<char>& charValues, std::vector<int>& isNullValues ) const;

        // Project 011450 changes
        void getCharArrayPreConditions( METHOD_message_t*  msgData, int* num, char** value, logical** isNull ) const;
        void getCharArrayPreActions( METHOD_message_t*  msgData, int* num, char** value, logical** isNull ) const;
        void getCharArrayBaseAction( METHOD_message_t*  msgData, int* num, char** value, logical** isNull ) const;
        void getCharArrayPostActions( METHOD_message_t*  msgData, int* num, char** value, logical** isNull ) const;

        void getCharArray( const Teamcenter::BusinessObject* obj, std::vector<char>& charValues, std::vector<int>& isNullValues ) const;

        void execute( Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
        void execute( tag_t objTag, va_list  args ) const;
        void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


        //Fix compiler warnings that were hiding virtual functions
        using Teamcenter::OperationDispatcher::executePreConditions;
        using Teamcenter::OperationDispatcher::executePreActions;
        using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //getCharArrayOperationDispatcher_HXX
